#!/usr/bin/perl

my $module = "sfsnet";

#
# first machine
#

my $mach0  = "jfk1-gblx.ron.lcs.mit.edu";
my $home0  = "/users/home/benjie/pastwatch.dist";
my $keyf0   = "$home0/exp2/key0";
my $root0  = "/users/home/benjie/.pastwatch";
my $w0     = "$home0/exp2/$mach0/w0";
my $past0  = "$home0/bin/pastwatch";
my $lsd0   = "216.165.108.39:20000";
my $dir0   = "$home0/exp2/";
my $rpcw0  = 64;
my $base   = "$home0/exp2/base";   # only used for import

#
# second machine
#

my $mach1  = "ana1-gblx.ron.lcs.mit.edu";
my $home1  = "/users/home/benjie/pastwatch.dist";
my $keyf1   = "$home1/exp2/$mach1/key1";
my $root1  = "/users/home/benjie/.pastwatch";
my $w1     = "$home1/exp2/$mach1/w1";
my $past1  = "$home1/bin/pastwatch";
my $lsd1   = "216.165.108.39:20000";
my $dir1   = "$home1/exp2/";
my $rpcw1  = 64;

system ("date");

# first, create a view

system ("rm -rf ~/.pastwatch/test");
my $o = `setenv LSD_TCPSOCKET $lsd0; export LSD_TCPSOCKET=$lsd0; pastview test`;

my $view;
my $keyh0;
my $keyh1;

if ($o =~ /New view: (\S+)/) {
  $view = $1;
  print "view: $view\n";
}
if ($o =~ /New keyhash: (\S+)/) {
  $keyh0 = $1;
  print "key0: $keyh0\n";
}

$o = `setenv LSD_TCPSOCKET $lsd0; export LSD_TCPSOCKET=$lsd0; pastview -j $view test`;
if ($o =~ /New keyhash: (\S+)/) {
  $keyh1 = $1;
  print "key1: $keyh1\n";
}

system ("scp ~/.pastwatch/test/key.$keyh0 $mach0:$keyf0");
system ("scp ~/.pastwatch/test/key.$keyh1 $mach1:$keyf1");

# then, start working on two separate client machines

ssh ($mach0, "rm -rf $w0; mkdir -p $w0");
ssh ($mach1, "rm -rf $w1; mkdir -p $w1");

ssh ($mach0, "setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root0; setenv LSD_TCPSOCKET $lsd0; $past0 -v $view -s $keyf0 status a");
ssh ($mach1, "setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root1; setenv LSD_TCPSOCKET $lsd1; $past1 -v $view -s $keyf1 status a");

ssh ($mach0, "echo Import; cd $base; rm -rf pastwatch.core ; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root0; setenv LSD_TCPSOCKET $lsd0; setenv CFSRW_RPCWIN $rpcw0; time $past0 -v $view -s $keyf0 import -m checkin $module; echo Done Import");

ssh ($mach0, "sleep 15; echo Checkout Hot; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root0; setenv LSD_TCPSOCKET $lsd0; setenv CFSRW_RPCWIN $rpcw0; time $past0 -v $view -s $keyf0 checkout -d $w0/$module $module; echo Done Checkout Hot");

ssh ($mach1, "sleep 15; echo Checkout Cold; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root1; setenv LSD_TCPSOCKET $lsd1; setenv CFSRW_RPCWIN $rpcw1; time $past1 -v $view -s $keyf1 checkout -d $w1/$module $module; echo Done Checkout Cold");

sub doit {
  my ($w, $diffs) = @_;

  if ($w == 0) {
    ssh ($mach0, "sleep 5; cd $dir0; echo ===== $diffs ======; grep -c Index $diffs; wc $diffs");
    ssh ($mach0, "cd $w0; patch -f < $dir0/$diffs");
    ssh ($mach0, "cd $w0; /bin/rm -rf `find $module -print | grep \".orig\" | xargs`");
    ssh ($mach0, "cd $w0; /bin/rm -rf `find $module -print | grep \".rej\" | xargs`");
    ssh ($mach0, "cd $w0; /bin/rm -rf $w0/zzz; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root0; setenv LSD_TCPSOCKET $lsd0; setenv CFSRW_RPCWIN $rpcw0; $past0 -v $view -s $keyf0 update $module > $w0/zzz");
    ssh ($mach0, "cd $w0; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root0; setenv LSD_TCPSOCKET $lsd0; setenv CFSRW_RPCWIN $rpcw0; $dir0/add-past.pl $view $keyf0 $past0 $w0/zzz");
    ssh ($mach0, "echo Commit 0; cd $w0; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root0; setenv LSD_TCPSOCKET $lsd0; setenv CFSRW_RPCWIN $rpcw0; time $past0 -v $view -s $keyf0 commit -m $diffs $module; echo Done Commit 0");
    ssh ($mach0, "cd $w0; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root0; setenv LSD_TCPSOCKET $lsd0; setenv CFSRW_RPCWIN $rpcw0; $past0 -v $view -s $keyf0 update $module");
    ssh ($mach1, "sleep 5; echo Update Warm 1; cd $w1; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root1; setenv LSD_TCPSOCKET $lsd1; setenv CFSRW_RPCWIN $rpcw1; time $past1 -v $view -s $keyf1 update $module; echo Done Update Warm 1");
  }
  
  else {
    ssh ($mach1, "sleep 5; cd $dir1; echo ===== $diffs ======; grep -c Index $diffs; wc $diffs");
    ssh ($mach1, "cd $w1; patch -f < $dir1/$diffs");
    ssh ($mach1, "cd $w1; /bin/rm -rf `find $module -print | grep \".orig\" | xargs`");
    ssh ($mach1, "cd $w1; /bin/rm -rf `find $module -print | grep \".rej\" | xargs`");
    ssh ($mach1, "cd $w1; /bin/rm -rf $w1/zzz; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root1; setenv LSD_TCPSOCKET $lsd1; setenv CFSRW_RPCWIN $rpcw1; $past1 -v $view -s $keyf1 update $module > $w1/zzz");
    ssh ($mach1, "cd $w1; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root1; setenv LSD_TCPSOCKET $lsd1; setenv CFSRW_RPCWIN $rpcw1; $dir1/add-past.pl $view $keyf1 $past1 $w1/zzz");
    ssh ($mach1, "echo Commit 1; cd $w1; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root1; setenv LSD_TCPSOCKET $lsd1; setenv CFSRW_RPCWIN $rpcw1; time $past1 -v $view -s $keyf1 commit -m $diffs $module; echo Done Commit 1");
    ssh ($mach1, "cd $w1; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root1; setenv LSD_TCPSOCKET $lsd1; setenv CFSRW_RPCWIN $rpcw1; $past1 -v $view -s $keyf1 update $module");
    ssh ($mach0, "sleep 5; echo Update Warm 0; cd $w0; setenv CFSRW_CONNTIMER 30; setenv PASTWATCH_ROOT $root0; setenv LSD_TCPSOCKET $lsd0; setenv CFSRW_RPCWIN $rpcw0; time $past0 -v $view -s $keyf0 update $module; echo Done Update Warm 0");
  }
}

sub ssh {
  my($h, $cmd) = @_;
  my $c = "ssh -x -a $h '$cmd'";
  my $status = system($c);
  return $status;
}

system ("sleep 5; date");

doit (0, "patch-60");
doit (1, "patch-61");
doit (0, "patch-62");
doit (1, "patch-63");
doit (0, "patch-64");
doit (1, "patch-65");
doit (0, "patch-66");
doit (1, "patch-67");
doit (0, "patch-68");
doit (1, "patch-69");
doit (0, "patch-70");
doit (1, "patch-71");
doit (0, "patch-72");
doit (1, "patch-73");
doit (0, "patch-74");
doit (1, "patch-75");
doit (0, "patch-76");
doit (1, "patch-77");
doit (0, "patch-78");
doit (1, "patch-79");
doit (0, "patch-80");
doit (1, "patch-81");
doit (0, "patch-82");
doit (1, "patch-83");
doit (0, "patch-84");
doit (1, "patch-85");
doit (0, "patch-86");
doit (1, "patch-87");
doit (0, "patch-88");
doit (1, "patch-89");
doit (0, "patch-90");
doit (1, "patch-91");
doit (0, "patch-92");
doit (1, "patch-93");
doit (0, "patch-94");
doit (1, "patch-95");
doit (0, "patch-96");
doit (1, "patch-97");
doit (0, "patch-98");
doit (1, "patch-99");

system ("date");

