/*
 *  Copyright (C) 2002-2004  Massachusetts Institute of Technology
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2, or (at
 *  your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */

#ifndef LOGW_H
#define LOGW_H

#include "stdinc.h"
#include "vervec.h"
#include "record.h"

class delta;
class projinterface;

typedef callback<void, comvec, vervec, log_status>::ptr cbx;
typedef callback<void, bigint, log_status>::ref cbc;

class logw : public virtual refcount
{
public:
  static ptr<logw> alloc
    (bigint la, ptr<sfspriv> sk, bigint verf, ptr<projinterface> v, bigint va);

  virtual bigint head () const = 0;
  virtual unsigned seqn () const = 0;

  virtual void rlock   (bigint h, const comvec& v,
                        const vervec& pkv, cbx cb) = 0;
  virtual void prepare (bigint h, const comvec& v,
                        const vervec& pkv, cbx cb) = 0;
  virtual void rlock   (bigint h, cbx cb) = 0;
  virtual void prepare (bigint h, cbx cb) = 0;
  virtual void append  (ptr<delta>) = 0;
  virtual void commit  (ptr<commit_record> c, cbc cb) = 0;
  virtual void abort   (cbl cb) = 0;
};

#endif

