/*
 *  Copyright (C) 2005  Massachusetts Institute of Technology
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2, or (at
 *  your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 *  USA
 */

#ifndef STATS_H
#define STATS_H

class past_stats {
public:
  past_stats (int argc, char **argv);
  void append_to_log ();
  str read_log ();
  void truncate_log ();

  void set_projid (bigint projid);
  void set_memberid (bigint memberid);
  void set_logid (bigint logid);
  void set_server_ip (str server);

  void set_connected (bool connected);
  void set_branched (bool branched);
  void add_dht_bytes (unsigned new_bytes);
  void add_snapshot_bytes (unsigned new_bytes);
  void add_sent_bytes (unsigned new_bytes);

  // This is a meaningless number because we are sloppy with how many reads we make to the replica.
  void add_replica_bytes (unsigned new_bytes); 
  
  
private:
  bigint _projid;
  bigint _memberid;
  bigint _logid;
  str _server;

  bool _connected;
  bool _branched;
  unsigned _dht_bytes;
  unsigned _replica_bytes;
  unsigned _snapshot_bytes;
  unsigned _sent_bytes;
  vec<str> _args;
  struct timeval _time;
  
  str gen_log_line ();

};

#endif
